
; ########################################### Variablen ####################################################

Structure Main
  Name.s
  Exit.l
  List_Refresh_Time.l
EndStructure
Global Main.Main

Structure Window_Main
  ID.l
  ListIcon.l
  Frame3D.l
  Editor.l [2]
  Button.l [2]
  IPAddress.l
EndStructure
Global Window_Main.Window_Main

Structure Peer
  SNet_Identity.l ; Identity fr das Netzwerk
  Name.s          ; Name dieses Peers
EndStructure
Global NewList Peer.Peer()

; ########################################### Includes #####################################################

XIncludeFile "Include\Simple_Network.pbi"

; ########################################### Proceduren ###################################################

Procedure Open_Window_Main()
  Window_Main\ID = OpenWindow(#PB_Any, 0, 0, 700, 500, "Simple Net - Chat Beispiel",  #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered)
  If Window_Main\ID
    If UseGadgetList(WindowID(Window_Main\ID))
      Window_Main\ListIcon = ListIconGadget(#PB_Any, 0, 0, 180, 390, "Name", 100, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
      AddGadgetColumn(Window_Main\ListIcon, 1, "Ping", 50)
      
      Window_Main\Frame3D = Frame3DGadget(#PB_Any, 10, 400, 160, 90, "Verbinden")
      Window_Main\IPAddress = IPAddressGadget(#PB_Any, 20, 420, 140, 20)
      Window_Main\Button [1] = ButtonGadget(#PB_Any, 20, 450, 140, 30, "Verbinden")
      
      Window_Main\Editor [0] = EditorGadget(#PB_Any, 180, 0, 520, 410, #PB_Editor_ReadOnly)
      Window_Main\Editor [1] = EditorGadget(#PB_Any, 180, 410, 430, 90)
      Window_Main\Button [0] = ButtonGadget(#PB_Any, 610, 410, 90, 90, "Senden")
      
    EndIf
  EndIf
EndProcedure

Procedure Show_Message(Message.s)
  AddGadgetItem(Window_Main\Editor [0], -1, Message)
EndProcedure

Procedure Send_Name(SNet_Identity)
  ForEach Peer()
    If Peer()\SNet_Identity = SNet_Identity
      SNet_New_Package()
      SNet_Write_Byte(1)
      SNet_Write_String(Main\Name)
      SNet_Close_Package(Peer()\SNet_Identity, 1, 1)
      Break
    EndIf
  Next
EndProcedure

Procedure Send_Message(SNet_Identity, Message.s)
  ForEach Peer()
    If Peer()\SNet_Identity = SNet_Identity
      SNet_New_Package()
      SNet_Write_Byte(2)
      SNet_Write_String(Message)
      SNet_Close_Package(Peer()\SNet_Identity, 1, 1)
      Break
    EndIf
  Next
EndProcedure

Procedure Update_Userlist()
  ClearGadgetItems(Window_Main\ListIcon)
  
  Counter = 0
  ForEach Peer()
    Ping = SNet_Peer_Get_Ping(Peer()\SNet_Identity)
    AddGadgetItem(Window_Main\ListIcon, Counter, Peer()\Name)
    SetGadgetItemText(Window_Main\ListIcon, Counter, Str(Ping), 1)
    Counter + 1
  Next
EndProcedure

; ########################################### Initkram #####################################################

Open_Window_Main()

Main\Name = InputRequester("Chat Beispiel", "Geben sie ihren Namen ein:", "User")

SNet_Options\Own_Identity = Random(2147483647)
SNet_Options\Port_TCP = 8240
SNet_Options\Port_UDP = 8241

SNet_Options\No_Server = 0
SNet_Options\No_Client = 0

SNet_Init()



; ########################################### Hauptschleife ################################################

Repeat
  SNet_Event = SNet_Event()
  Select SNet_Event
    Case #SNet_Event_Peer_New
      Identity = SNet_Event_Peer()
      Show_Message("Neuer Peer: "+Str(Identity))
      AddElement(Peer())
      Peer()\SNet_Identity = Identity
      Send_Name(Identity)
      
    Case #SNet_Event_Data
      Identity = SNet_Event_Peer()
      ForEach Peer()
        If Peer()\SNet_Identity = Identity
          Data_Type = SNet_Read_Byte() ; Das erste byte beschreibt den Paketinhalt
          Select Data_Type
            Case 1 ; Identifizierung (Name)
              Peer()\Name = SNet_Read_String()
              Show_Message("Name empfangen: "+Peer()\Name)
              
            Case 2 ; Nachricht empfangen
              Message.s = SNet_Read_String()
              Show_Message(Peer()\Name+": "+Message)
              
          EndSelect
          Break
        EndIf
      Next
      
    Case #SNet_Event_Peer_Deleted
      Identity = SNet_Event_Peer()
      ForEach Peer()
        If Peer()\SNet_Identity = Identity
          Show_Message("Peer gelscht: "+Str(Identity)+" ("+Peer()\Name+")")
          DeleteElement(Peer())
          Break
        EndIf
      Next
      
  EndSelect
  
  Window_Event = WaitWindowEvent(100)
  Select Window_Event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case Window_Main\Button [0]
          Message.s = GetGadgetText(Window_Main\Editor [1])
          Counter = 0
          ForEach Peer()
            ;If GetGadgetState(Window_Main\ListIcon) = Counter
            Send_Message(Peer()\SNet_Identity, Message)
            ;EndIf
            Counter + 1
          Next
          SetGadgetText(Window_Main\Editor [1], "")
        
        Case Window_Main\Button [1]
          IP = GetGadgetState(Window_Main\IPAddress)
          SNet_Connect(IP)
          
      EndSelect
      
    Case #PB_Event_CloseWindow
      Main\Exit = 1
      
  EndSelect
  
  ; ############## Userliste erneuern
  
  If List_Refresh_Time < ElapsedMilliseconds()
    List_Refresh_Time = ElapsedMilliseconds() + 500
    Update_Userlist()
  EndIf
Until Main\Exit = 1

; ########################################### Beenden ######################################################

SNet_Deinit()
; IDE Options = PureBasic 4.30 Beta 5 (Windows - x86)
; CursorPosition = 106
; FirstLine = 76
; Folding = -
; EnableXP
; DisableDebugger